<?php
/**
 * This file is part of Cloudboard
 * @Author: Filip 'SimLay' Cichorek
 * @website: http://cichorekfilip.pl
 * Copyright (c) 2021
 **/
if (!defined('IN_MYBB')) {
    die("🇩‌🇮‌🇷‌🇪‌🇨‌🇹‌ 🇮‌🇳‌🇮‌🇹‌🇮‌🇦‌🇱‌🇮‌🇿‌🇦‌🇹‌🇮‌🇴‌🇳‌ 🇴‌🇫‌ 🇹‌🇭‌🇮‌🇸‌ 🇫‌🇮‌🇱‌🇪‌ 🇮‌🇸‌ 🇳‌🇴‌🇹‌ 🇦‌🇱‌🇱‌🇴‌🇼‌🇪‌🇩‌.<br /><br />🇵‌🇱‌🇪‌🇦‌🇸‌🇪‌ 🇲‌🇦‌🇰‌🇪‌ 🇸‌🇺‌🇷‌🇪‌ 🇮‌🇳‌_🇲‌🇾‌🇧‌🇧‌ 🇮‌🇸‌ 🇩‌🇪‌🇫‌🇮‌🇳‌🇪‌🇩‌. <br /><br />🇹‌🇴‌🇩‌🇦‌🇾‌ 🇮‌🇲‌🇵‌🇴‌🇸‌🇸‌🇮‌🇧‌🇱‌🇪‌ 🇧‌🇪‌🇨‌🇦‌🇲‌🇪‌ 🇵‌🇴‌🇸‌🇸‌🇮‌🇧‌🇱‌🇪‌");
}


$page->add_breadcrumb_item($lang->cloudboard_name, "index.php?module=cloudboard-logs");
if($mybb->input['action'] == 'edit' || !$mybb->input['action']) {
	$sub_tabs['list'] = array(
		'title'			=> $lang->cloudboard_logs,
		'link'		  => 'index.php?module=cloudboard-logs',
        'description' => $lang->cloudboard_logs_desc,
	);
}


if(!$mybb->input['action']) {
    $page->output_header($lang->cloudboard_name." - ".$lang->cloudboard_logs);
    $page->output_nav_tabs($sub_tabs, 'list');
    $table = new Table;
    $table->construct_header($lang->cloudboard_user, ['width' => '10%']);
    $table->construct_header($lang->cloudboard_module, ['width' => '10%']);
    $table->construct_header($lang->cloudboard_title, ['width' => '10%']);
    $table->construct_header($lang->cloudboard_date, ['width' => '10%']);
    $table->construct_header($lang->cloudboard_ip, ['width' => '10%']);

    $url = "{$mybb->settings['bburl']}/admin/index.php?module=cloudboard-logs";
    $per_page = 10;

    $query = $db->simple_select('cblogs', 'COUNT(*) AS cblogs');
    $num_cblogs = $db->fetch_field($query, "cblogs");

    $pagenum = $mybb->get_input('page', MyBB::INPUT_INT);
    if($pagenum && $pagenum > 0)
    {
        $start = ($pagenum - 1) * $per_page;
        $pages = ceil($num_cblogs/ $per_page);
        if($pagenum > $pages)
        {
            $start = 0;
            $pagenum = 1;
        }
    }
    else
    {
        $start = 0;
        $pagenum = 1;
    };

    $multipage = multipage($num_cblogs, $per_page, $pagenum, $url);

    echo $multipage;

    $logs = $db->simple_select('cblogs', '*', '', array('limit' => "{$start}, {$per_page}", 'order_by' => 'date DESC'));
    while($row = $db->fetch_array($logs))
    {
        if($row['uid'] > 0)
        {
            $uid  = $row['uid'];
            $user = get_user($uid);
        }

        $table->construct_cell(build_profile_link(format_name($user['username'], $user['usergroup'], $user['displaygroup']), (int)$uid));
        $table->construct_cell($row['module']);
        $table->construct_cell($row['description']);
        $table->construct_cell(htmlspecialchars_uni(my_date('d.m.y | H:i', $row['date'])));
        $table->construct_cell(my_inet_ntop($row['ip']));
        $table->construct_row();
    }
    if($table->num_rows()  == 0)
    {
        $table->construct_cell($lang->cloudboard_none, ['colspan' => 6]);
        $table->construct_row();
    }

    $table->output();
    $page->output_footer();
}
