<?php
/**
 * This file is part of Cloudboard
 * @Author: Filip 'SimLay' Cichorek
 * @website: http://cichorekfilip.pl
 * Copyright (c) 2021
 **/
if (!defined('IN_MYBB')) {
    die("🇩‌🇮‌🇷‌🇪‌🇨‌🇹‌ 🇮‌🇳‌🇮‌🇹‌🇮‌🇦‌🇱‌🇮‌🇿‌🇦‌🇹‌🇮‌🇴‌🇳‌ 🇴‌🇫‌ 🇹‌🇭‌🇮‌🇸‌ 🇫‌🇮‌🇱‌🇪‌ 🇮‌🇸‌ 🇳‌🇴‌🇹‌ 🇦‌🇱‌🇱‌🇴‌🇼‌🇪‌🇩‌.<br /><br />🇵‌🇱‌🇪‌🇦‌🇸‌🇪‌ 🇲‌🇦‌🇰‌🇪‌ 🇸‌🇺‌🇷‌🇪‌ 🇮‌🇳‌_🇲‌🇾‌🇧‌🇧‌ 🇮‌🇸‌ 🇩‌🇪‌🇫‌🇮‌🇳‌🇪‌🇩‌. <br /><br />🇹‌🇴‌🇩‌🇦‌🇾‌ 🇮‌🇲‌🇵‌🇴‌🇸‌🇸‌🇮‌🇧‌🇱‌🇪‌ 🇧‌🇪‌🇨‌🇦‌🇲‌🇪‌ 🇵‌🇴‌🇸‌🇸‌🇮‌🇧‌🇱‌🇪‌");
}
/** Przygotowane pod plugin aby w momencie wyłączenia go strona nie istniała
 * Jeśli teston = false wyskakuje komunikat zainstaluj plugin
 */
/** @var  $teston */

/**
 * @return bool true
 */

    function cloudboard_meta()
    {
        global $page, $lang, $plugins, $moduleStatus;
            if(function_exists('cloudboard_info')) {
                $moduleStatus = 1;
                $sub_menu = array();
                $sub_menu['10'] = array("id" => "summary", "title" => $lang->cloudboard_summary, "link" => "index.php?module=cloudboard-summary");
                $sub_menu['20'] = array("id" => "menu", "title" => $lang->cloudboard_menu, "link" => "index.php?module=cloudboard-menu");
                $sub_menu['30'] = array("id" => "team", "title" => $lang->cloudboard_team, "link" => "index.php?module=cloudboard-team");
                $sub_menu['40'] = array("id" => "backup", "title" => $lang->cloudboard_backup, "link" => "index.php?module=cloudboard-backup");
                $sub_menu['50'] = array("id" => "logs", "title" => $lang->cloudboard_logs, "link" => "index.php?module=cloudboard-logs");
                $sub_menu['60'] = array("id" => "settings", "title" => $lang->cloudboard_settings, "link" => "index.php?module=cloudboard-settings");

                $sub_menu = $plugins->run_hooks("admin_cloudboard_menu", $sub_menu);

                $page->add_menu_item($lang->cloudboard_name, "cloudboard", "index.php?module=cloudboard", 70, $sub_menu);

                return true;
            }
        }

    /**
     * @param string $action
     *
     * @return string
     */
    function cloudboard_action_handler($action)
    {
        global $page, $plugins;

        $page->active_module = "cloudboard";

        $actions = array(
            'summary' => array('active' => 'summary', 'file' => 'summary.php'),
            'menu' => array('active' => 'menu', 'file' => 'menu.php'),
            'team' => array('active' => 'team', 'file' => 'team.php'),
            'backup' => array('active' => 'backup', 'file' => 'backup.php'),
            'logs' => array('active' => 'logs', 'file' => 'logs.php'),
            'settings' => array('active' => 'settings', 'file' => 'settings.php'),
        );

        $actions = $plugins->run_hooks("admin_cloudboard_action_handler", $actions);

        if (isset($actions[$action])) {
            $page->active_action = $actions[$action]['active'];
            return $actions[$action]['file'];
        } else {
            $page->active_action = "summary";
            return "summary.php";
        }
    }

    /**
     * @return array
     */
    function cloudboard_admin_permissions()
    {
        global $lang, $plugins;

        $admin_permissions = array(
            "summary" => "$lang->cloudboard_summary_perm",
            "menu" => "$lang->cloudboard_menu_perm",
            "team" => "$lang->cloudboard_team_perm",
            "logs" => "$lang->cloudboard_logs_perm",
            "backup" => "$lang->cloudboard_backup_perm"
        );

        $admin_permissions = $plugins->run_hooks("admin_cloudboard_permissions", $admin_permissions);

        return array("name" => $lang->filboard_name, "permissions" => $admin_permissions, "disporder" => 20);
    }
