<?php
/**
 * This file is part of Cloudboard
 * @Author: Filip 'SimLay' Cichorek
 * @website: http://cichorekfilip.pl
 * Copyright (c) 2021
 **/
if (!defined('IN_MYBB')) {
    die("🇩‌🇮‌🇷‌🇪‌🇨‌🇹‌ 🇮‌🇳‌🇮‌🇹‌🇮‌🇦‌🇱‌🇮‌🇿‌🇦‌🇹‌🇮‌🇴‌🇳‌ 🇴‌🇫‌ 🇹‌🇭‌🇮‌🇸‌ 🇫‌🇮‌🇱‌🇪‌ 🇮‌🇸‌ 🇳‌🇴‌🇹‌ 🇦‌🇱‌🇱‌🇴‌🇼‌🇪‌🇩‌.<br /><br />🇵‌🇱‌🇪‌🇦‌🇸‌🇪‌ 🇲‌🇦‌🇰‌🇪‌ 🇸‌🇺‌🇷‌🇪‌ 🇮‌🇳‌_🇲‌🇾‌🇧‌🇧‌ 🇮‌🇸‌ 🇩‌🇪‌🇫‌🇮‌🇳‌🇪‌🇩‌. <br /><br />🇹‌🇴‌🇩‌🇦‌🇾‌ 🇮‌🇲‌🇵‌🇴‌🇸‌🇸‌🇮‌🇧‌🇱‌🇪‌ 🇧‌🇪‌🇨‌🇦‌🇲‌🇪‌ 🇵‌🇴‌🇸‌🇸‌🇮‌🇧‌🇱‌🇪‌");
}



$page->add_breadcrumb_item($lang->cloudboard_name, "index.php?module=cloudboard-team");
if($mybb->input['action'] == 'add' || $mybb->input['action'] == 'edit' || !$mybb->input['action']) {
	$sub_tabs['list'] = array(
		'title'			=> $lang->cloudboard_team,
		'link'		  => 'index.php?module=cloudboard-team',
        'description' => $lang->cloudboard_team_desc,
	);
	$sub_tabs['add'] = array(
		'title'			=> $lang->cloudboard_add,
		'link'		  => 'index.php?module=cloudboard-team&action=add',
        'description' => $lang->cloudboard_add_desc,
	);
}



if(!$mybb->input['action']) {
    $page->output_header($lang->cloudboard_name." - ".$lang->cloudboard_team);
    $page->output_nav_tabs($sub_tabs, 'list');
    $table = new Table;
    $table->construct_header('', ['width' => '1%','class' => 'align_center']);
    $table->construct_header($lang->cloudboard_user, ['width' => '20%']);
    $table->construct_header($lang->cloudboard_email, ['width' => '20%']);
    $table->construct_header($lang->cloudboard_customfield, ['width' => '21%']);
    $table->construct_header('', ['width' => '1%', 'class' => 'align_center']);
    $team = $db->simple_select("cbteam", '*', '', array('order_by' => 'sort ASC'));
    while($row = $db->fetch_array($team))    {
        if($row['uid'] > 0)
        {
            $uid  = $row['uid'];
            $user = get_user($uid);
        }
        $table->construct_cell($row['sort'], ['class' => 'align_center']);
        $table->construct_cell(build_profile_link(format_name($user['username'], $user['usergroup'], $user['displaygroup']), (int)$uid));
        $table->construct_cell($row['email']);
        $table->construct_cell('<div style="display: flex; flex-flow: row; align-items: center">
                                    <i class="'.$row['customfieldIcon'].'" style="font-size: 23px; margin: 0 5px 0 0;"></i>
                                    <a href="'.$row['customfieldLink'].'">'.$row['customfieldName'].'</a>
                                 </div>', ['class' => 'align_center']);
        $popup = new PopupMenu("team{$row['id']}", '<i class="ri-more-line"></i>');
        $popup->add_item($lang->cloudboard_edit, "index.php?module=cloudboard-team&amp;action=edit&amp;id={$row['id']}");
        $popup->add_item($lang->cloudboard_delete, "index.php?module=cloudboard-team&amp;action=delete&amp;id={$row['id']}");
        $table->construct_cell($popup->fetch(), ['class' => 'align_center']);
        $table->construct_row();
    }
    if($table->num_rows()  == 0)
    {
        $table->construct_cell($lang->cloudboard_none, ['colspan' => 6]);
        $table->construct_row();
    }
    $table->output();
    $page->output_footer();
}

if($mybb->input['action'] == 'add') {

    if($mybb->request_method == "post")
    {
        if(empty($mybb->input['uid'])) {
            flash_message($lang->cloudboard_empty, "error");
            admin_redirect("index.php?module=cloudboard-team&amp;action=add");
        } else {
            $data = array(
                "uid"               => $db->escape_string($mybb->input['uid']),
                "email"             => $db->escape_string($mybb->input['email']),
                "customfieldIcon"   => $db->escape_string($mybb->input['customfieldIcon']),
                "customfieldName"   => $db->escape_string($mybb->input['customfieldName']),
                "customfieldLink"   => $db->escape_string($mybb->input['customfieldLink']),
                "sort"              => $db->escape_string($mybb->input['sort']),
            );
            $db->insert_query("cbteam", $data);

            /** Logs */
            if($mybb->input['uid'] > 0)
            {
                $uid  = $mybb->input['uid'];
                $user = get_user($uid);
            }
            $logElement = build_profile_link(format_name($user['username'], $user['usergroup'], $user['displaygroup']), (int)$uid);
            cbAdminLog("new", $lang->cloudboard_team, $logElement);


            flash_message($lang->cloudboard_added, "success");
            admin_redirect("index.php?module=cloudboard-team");
        }
    } else {
        $page->output_header($lang->cloudboard_name." - ".$lang->cloudboard_add);
        $page->output_nav_tabs($sub_tabs, 'add');
        $form = new Form("index.php?module=cloudboard-team&amp;action=add", "post", "team");
        $form_container = new FormContainer($lang->cloudboard_add);
        $form_container->output_row($lang->cloudboard_user, $lang->cloudboard_user_desc, $form->generate_numeric_field('uid', '', array('id' => 'uid'), 'uid'));
        $form_container->output_row($lang->cloudboard_email, $lang->cloudboard_email_desc, $form->generate_text_box('email', '', array('id' => 'email'), 'email'));
        $form_container->output_row("<div>".$lang->cloudboard_customfield."</div><br />".$lang->cloudboard_icon, $lang->cloudboard_icon_desc, "<div style='display: flex; flex-flow: row; align-items: center'>".$form->generate_text_box('customfieldIcon', '', array('id' => 'customfieldIcon'), 'customfieldIcon')."<i id='iconCheck' style='padding:0 0 0 6px; font-size: 20px' class=''></i></div>");
        $form_container->output_row($lang->cloudboard_title, $lang->cloudboard_title_desc, $form->generate_text_box('customfieldName', '', array('id' => 'customfieldName'), 'customfieldName'));
        $form_container->output_row($lang->cloudboard_url, $lang->cloudboard_url_desc, $form->generate_text_box('customfieldLink', '', array('id' => 'customfieldLink'), 'customfieldLink'));
        $form_container->output_row($lang->cloudboard_sort, $lang->cloudboard_sort_desc, $form->generate_numeric_field('sort', '', array('id' => 'sort'), 'sort'));
        echo '<script src="/jscripts/cloudboard/iconcheck.js"></script>';
        $form_container->end();
        $buttons = array();
        $buttons[] = $form->generate_submit_button($lang->cloudboard_add_el);
        $form->output_submit_wrapper($buttons);
        $form->end();
        $page->output_footer();
    }
}

if($mybb->input['action'] == 'edit')
{
    if($mybb->request_method == "post")
    {
        $query = $db->simple_select("cbteam", "*", "`id` =\"".intval($mybb->input['id'])."\"");
        $row = $db->fetch_array($query);
        if(!$row)
        {
            flash_message($lang->cloudboard_404, "error");
            admin_redirect("index.php?module=cloudboard-team");
        }
        if(empty($mybb->input['uid'])) {
            flash_message($lang->cloudboard_empty, "error");
            admin_redirect("index.php?module=cloudboard-team&amp;action=edit&amp;id={$row['id']}");
        } else {
            $data = array(
                "uid"               => $db->escape_string($mybb->input['uid']),
                "email"             => $db->escape_string($mybb->input['email']),
                "customfieldIcon"   => $db->escape_string($mybb->input['customfieldIcon']),
                "customfieldName"   => $db->escape_string($mybb->input['customfieldName']),
                "customfieldLink"   => $db->escape_string($mybb->input['customfieldLink']),
                "sort"              => $db->escape_string($mybb->input['sort']),
            );
            $db->update_query("cbteam", $data, "`id` = \"".$row['id']."\"");


            /** Logs */
            if($row['uid'] > 0)
            {
                $uid  = $row['uid'];
                $user = get_user($uid);
            }
            $logElement = build_profile_link(format_name($user['username'], $user['usergroup'], $user['displaygroup']), (int)$uid);
            cbAdminLog("edit", $lang->cloudboard_team, $logElement);

            flash_message($lang->cloudboard_edited, "success");
            admin_redirect("index.php?module=cloudboard-team");
        }
    } else {
        $page->output_header($lang->cloudboard_name." - ".$lang->cloudboard_edit);
        $page->output_nav_tabs($sub_tabs, 'list');
        if(!$mybb->input['id']) {
            admin_redirect("index.php?module=cloudboard-team");
        }
        $query = $db->simple_select("cbteam", "*", "id=\"".intval($mybb->input['id'])."\"");
        $row = $db->fetch_array($query);
        $form = new Form("index.php?module=cloudboard-team&amp;action=edit", "post", "team");
        echo $form->generate_hidden_field("id", $row['id']);
        $form_container = new FormContainer($lang->cloudboard_edit);
        $form_container->output_row($lang->cloudboard_user, $lang->cloudboard_user_desc, $form->generate_numeric_field('uid', $row['uid'], array('id' => 'uid'), 'uid'));
        $form_container->output_row($lang->cloudboard_email, $lang->cloudboard_email_desc, $form->generate_text_box('email', $row['email'], array('id' => 'email'), 'email'));
        $form_container->output_row("<div>".$lang->cloudboard_customfield."</div><br />".$lang->cloudboard_icon, $lang->cloudboard_icon_desc, "<div style='display: flex; flex-flow: row; align-items: center'>".$form->generate_text_box('customfieldIcon', $row['customfieldIcon'], array('id' => 'customfieldIcon'), 'customfieldIcon')."<i id='iconCheck' style='padding:0 0 0 6px; font-size: 20px' class=''></i></div>");
        $form_container->output_row($lang->cloudboard_title, $lang->cloudboard_title_desc, $form->generate_text_box('customfieldName', $row['customfieldName'], array('id' => 'customfieldName'), 'customfieldName'));
        $form_container->output_row($lang->cloudboard_url, $lang->cloudboard_url_desc, $form->generate_text_box('customfieldLink', $row['customfieldLink'], array('id' => 'customfieldLink'), 'customfieldLink'));
        $form_container->output_row($lang->cloudboard_sort, $lang->cloudboard_sort_desc, $form->generate_numeric_field('sort', $row['sort'], array('id' => 'sort'), 'sort'));
        echo '<script src="/jscripts/cloudboard/iconcheck.js"></script>';
        $form_container->end();
        $buttons = array();
        $buttons[] = $form->generate_submit_button($lang->cloudboard_edit);
        $form->output_submit_wrapper($buttons);
        $form->end();
        $page->output_footer();
    }
}

if($mybb->input['action'] == 'delete')
{
    if($mybb->input['no'])
    {
        admin_redirect("index.php?module=cloudboard-team");
    }
    if($mybb->request_method == "post") {
        $mybb->binary_fields['cblogs'] = ['ip' => true];
        $query = $db->simple_select("cbteam", "*", "id=\"".intval($mybb->input['id'])."\"");
        $row = $db->fetch_array($query);
        /** Logs */
        if($row['uid'] > 0)
        {
            $uid  = $row['uid'];
            $user = get_user($uid);
        }
        $logElement = build_profile_link(format_name($user['username'], $user['usergroup'], $user['displaygroup']), (int)$uid);
        cbAdminLog("del", $lang->cloudboard_team, $logElement);

        $db->delete_query("cbteam", "`id`=".intval($mybb->input['id'])."");
        admin_redirect("index.php?module=cloudboard-team");
        flash_message($lang->cloudboard_deleted, "success");
    } else {
        $page->output_header($lang->cloudboard_name." - ".$lang->cloudboard_delete);
        $page->add_breadcrumb_item($lang->cloudboard_delete);
        $mybb->input['id'] = intval($mybb->input['id']);
        $form = new Form("index.php?module=cloudboard-team&amp;action=delete&amp;id={$mybb->input['id']}", 'post');
        echo "<div class=\"confirm_action\">\n";
        echo "<p>{$lang->cloudboard_delete_confirm}</p>\n";
        echo "<br />\n";
        echo "<p class=\"buttons\">\n";
        echo $form->generate_submit_button($lang->cloudboard_yes, array('class' => 'button_yes'));
        echo $form->generate_submit_button($lang->cloudboard_no, array("name" => "no", 'class' => 'button_no'));
        echo "</p>\n";
        echo "</div>\n";
        $form->end();
        $page->output_footer();
    }
}
