<?php

class Page extends DefaultPage
{
    public $tab_control;

    function output_header($title="")
    {
        global $mybb, $admin_session, $lang, $plugins;

        $args = array(
            'this' => &$this,
            'title' => &$title,
        );

        $plugins->run_hooks("admin_page_output_header", $args);

        if(!$title)
        {
            $title = $lang->mybb_admin_panel;
        }

        $rtl = "";
        if($lang->settings['rtl'] == 1)
        {
            $rtl = " dir=\"rtl\"";
        }

        /** Format admin user */
        if(empty($mybb->user['avatar']))
            $mybb->user['avatar'] = $mybb->settings['useravatar'];

        if (strpos($mybb->user['avatar'], 'http') === false)
            $avatar = "../".$mybb->user['avatar'];
        else
            $avatar = $mybb->user['avatar'];

        if($mybb->user['avatar'] && my_substr($mybb->user['avatar'], 0, 7) !== 'http://' && my_substr($mybb->user['avatar'], 0, 8) !== 'https://')
            $avatar = "../{$mybb->user['avatar']}";

        if(!$mybb->user['avatar'])
            $avatar = "../".$mybb->settings['useravatar'];
        $usernameStyled = format_name(htmlspecialchars_uni($mybb->user['username']), $mybb->user['usergroup'], $mybb->user['displaygroup']);


        echo "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\n";
        echo "<html xmlns=\"http://www.w3.org/1999/xhtml\"{$rtl}>\n";
        echo "<head profile=\"http://gmpg.org/xfn/1\">\n";
        echo "	<title>".$title."</title>\n";
        echo "	<meta name=\"author\" content=\"MyBB Group\" />\n";
        echo "	<meta name=\"copyright\" content=\"Copyright ".COPY_YEAR." MyBB Group.\" />\n";
        echo "	<link rel=\"stylesheet\" href=\"styles/".$this->style."/main.css?ver=1813\" type=\"text/css\" />\n";
        echo "	<link rel=\"stylesheet\" href=\"styles/".$this->style."/modal.css?ver=1813\" type=\"text/css\" />\n";
        echo "	<link rel=\"stylesheet\" href=\"styles/".$this->style."/style.css\" type=\"text/css\" />\n";

        // Load stylesheet for this module if it has one
        if(file_exists(MYBB_ADMIN_DIR."styles/{$this->style}/{$this->active_module}.css"))
        {
            echo "	<link rel=\"stylesheet\" href=\"styles/{$this->style}/{$this->active_module}.css\" type=\"text/css\" />\n";
        }

        echo "	<script type=\"text/javascript\" src=\"../jscripts/jquery.js?ver=1823\"></script>\n";
        echo "	<script type=\"text/javascript\" src=\"../jscripts/jquery.plugins.min.js?ver=1821\"></script>\n";
        echo "	<script type=\"text/javascript\" src=\"../jscripts/general.js?ver=1821\"></script>\n";
        echo "	<script type=\"text/javascript\" src=\"./jscripts/admincp.js?ver=1821\"></script>\n";
        echo "	<script type=\"text/javascript\" src=\"./jscripts/tabs.js\"></script>\n";

        /** custom */
        echo "	<script type=\"text/javascript\" src=\"styles/{$this->style}/js/global.js\"></script>\n";
        echo "	<script src=\"https://cdn.jsdelivr.net/npm/simplebar@latest/dist/simplebar.min.js\"></script>\n";
        echo "  <link rel=\"stylesheet\" href=\"https://cdn.jsdelivr.net/npm/simplebar@latest/dist/simplebar.css\" />\n";

        echo "	<link rel=\"stylesheet\" href=\"jscripts/jqueryui/css/redmond/jquery-ui.min.css\" />\n";
        echo "	<link rel=\"stylesheet\" href=\"jscripts/jqueryui/css/redmond/jquery-ui.structure.min.css\" />\n";
        echo "	<link rel=\"stylesheet\" href=\"jscripts/jqueryui/css/redmond/jquery-ui.theme.min.css\" />\n";
        echo "	<script src=\"jscripts/jqueryui/js/jquery-ui.min.js?ver=1813\"></script>\n";

        // Stop JS elements showing while page is loading (JS supported browsers only)
        echo "  <style type=\"text/css\">.popup_button { display: none; } </style>\n";
        echo "  <script type=\"text/javascript\">\n".
            "//<![CDATA[\n".
            "	document.write('<style type=\"text/css\">.popup_button { display: inline; } .popup_menu { display: none; }<\/style>');\n".
            "//]]>\n".
            "</script>\n";

        echo "	<script type=\"text/javascript\">
//<![CDATA[
var loading_text = '{$lang->loading_text}';
var cookieDomain = '{$mybb->settings['cookiedomain']}';
var cookiePath = '{$mybb->settings['cookiepath']}';
var cookiePrefix = '{$mybb->settings['cookieprefix']}';
var cookieSecureFlag = '{$mybb->settings['cookiesecureflag']}';
var imagepath = '../images';

lang.unknown_error = \"{$lang->unknown_error}\";
lang.saved = \"{$lang->saved}\";
//]]>
</script>\n";
        echo $this->extra_header;
        $username = htmlspecialchars_uni($mybb->user['username']);
        print <<<EOF
</head>
<body class="module-{$this->active_module}">
    <nav id="mainNav" class="shrunk" data-simplebar>
                <div class="navContent">
            <a href="./index.php" class="logo" title="{$lang->home}">
                <div class="sygnet">
                <svg class="sygnet" xmlns="http://www.w3.org/2000/svg" width="495" height="343" viewBox="0 0 495 343" fill="none">
                  <path d="M448.462 181.37C436.607 165.86 420.222 153.993 401.893 147.538C401.134 103.154 364.793 67.2791 320.232 67.2791C313.254 67.2791 306.296 68.1891 299.487 69.9891C288.401 56.1791 274.415 44.6931 258.778 36.5931C240.786 27.2748 221.33 22.55 200.953 22.55C132.522 22.55 76.6165 77.2141 74.6058 145.167C31.0392 156.687 0 196.56 0 242.139C0 297.451 44.9993 342.45 100.311 342.45H368.688C424.001 342.45 469 297.451 469 242.139C469 219.961 461.897 198.948 448.462 181.37Z" fill="url(#paint0_linear)"/>
                  <path d="M474.462 159.37C462.607 143.86 446.222 131.993 427.893 125.538C427.134 81.1541 390.793 45.2791 346.232 45.2791C339.254 45.2791 332.296 46.1891 325.487 47.9891C314.401 34.1791 300.415 22.6931 284.778 14.5931C266.786 5.27479 247.33 0.549988 226.953 0.549988C158.522 0.549988 102.616 55.2141 100.606 123.167C57.0392 134.687 26 174.56 26 220.139C26 275.451 70.9993 320.45 126.311 320.45H394.688C450.001 320.45 495 275.451 495 220.139C495 197.961 487.897 176.948 474.462 159.37ZM394.688 306.202H126.311C78.8559 306.202 40.2486 267.595 40.2486 220.14C40.2486 179.332 69.2378 143.86 109.177 135.794L114.986 134.621L114.889 128.694C114.882 128.268 114.856 127.849 114.826 127.43C114.815 127.272 114.798 127.115 114.798 126.954C114.798 65.1121 165.11 14.7991 226.951 14.7991C262.799 14.7991 295.657 31.4361 317.097 60.4431L320.165 64.5921L325.064 62.9721C331.972 60.6871 339.094 59.5291 346.231 59.5291C383.409 59.5291 413.655 89.7741 413.655 126.954C413.655 127.545 413.609 128.22 413.561 128.936C413.53 129.399 413.499 129.862 413.476 130.326L413.198 135.955L418.613 137.521C436.173 142.599 451.988 153.431 463.14 168.021C474.661 183.093 480.75 201.114 480.75 220.138C480.751 267.594 442.143 306.202 394.688 306.202Z" fill="black"/>
                  <defs>
                  <linearGradient id="paint0_linear" x1="9.74915e-06" y1="23.0001" x2="234" y2="342" gradientUnits="userSpaceOnUse">
                  <stop offset="0.10" stop-color="#30BEF5"/>
                  <stop offset="1" stop-color="#6292FF"/>
                  </linearGradient>
                  </defs>
                </svg>
                </div>
                <div class="name">
                    CloudBoard
                </div>
                <div class="version">
                beta
                </div>
            </a>

                {$this->_build_menu()}
        </div>
    </nav>

    <section class="container" data-simplebar>
        <div class="wrapper">

EOF;

        function output_alert($message, $id="")
        {
            echo "<section class=\"alert {$id}Alert\">\n";
            echo "<i class=\"fas alert__icon  fa-info-circle\"></i>";
            echo "<div class=\"alert__message\">{$message}</div>\n";
            echo "</section>\n";
        }

        function output_inline_message($message)
        {
            echo "<section class=\"alert alert--inline_message\">\n";
            echo "<i class=\"fas alert__icon  fa-info-circle\"></i>";
            echo "<div class=\"alert__message\">{$message}</div>\n";
            echo "</section>\n";
        }

        function output_error($error)
        {
            echo "<section class=\"alert alert--error\">\n";
            echo "<i class=\"fas alert__icon  fa-exclamation-triangle\"></i>";
            echo "<div class=\"alert__message\">{$error}</div>\n";
            echo "</section>\n";
        }

        function output_inline_error($errors)
        {
            global $lang;

            if(!is_array($errors))
            {
                $errors = array($errors);
            }
            echo "<section class=\"alert alert--error\">\n";
            echo "<i class=\"fas alert__icon  fa-info-circle\"></i>";
            echo "<p><em>{$lang->encountered_errors}</em></p>\n";
            echo "<ul>\n";
            foreach($errors as $error)
            {
                echo "<li>{$error}</li>\n";
            }
            echo "</ul>\n";
            echo "</section>\n";
        }
        $cbIcon = [
            "success" => '
            <svg viewBox="0 0 500 500" fill="none" xmlns="http://www.w3.org/2000/svg">
              <path class="fill" d="M463.462 249.37C451.607 233.86 435.222 221.993 416.893 215.538C416.134 171.154 379.793 135.279 335.232 135.279C328.254 135.279 321.296 136.189 314.487 137.989C303.401 124.179 289.415 112.693 273.778 104.593C255.786 95.2747 236.33 90.5499 215.953 90.5499C147.522 90.5499 91.6165 145.214 89.6058 213.167C46.0392 224.687 15 264.56 15 310.139C15 365.451 59.9993 410.45 115.311 410.45H383.688C439.001 410.45 484 365.451 484 310.139C484 287.961 476.897 266.948 463.462 249.37ZM383.688 396.202H115.311C67.8559 396.202 29.2486 357.595 29.2486 310.14C29.2486 269.332 58.2378 233.86 98.177 225.794L103.986 224.621L103.889 218.694C103.882 218.268 103.856 217.849 103.826 217.43C103.815 217.272 103.798 217.115 103.798 216.954C103.798 155.112 154.11 104.799 215.951 104.799C251.799 104.799 284.657 121.436 306.097 150.443L309.165 154.592L314.064 152.972C320.972 150.687 328.094 149.529 335.231 149.529C372.409 149.529 402.655 179.774 402.655 216.954C402.655 217.545 402.609 218.22 402.561 218.936C402.53 219.399 402.499 219.862 402.476 220.326L402.198 225.955L407.613 227.521C425.173 232.599 440.988 243.431 452.14 258.021C463.661 273.093 469.75 291.114 469.75 310.138C469.751 357.594 431.143 396.202 383.688 396.202Z"/>
              <path class="fill" d="M139.23 193.158H153.479C153.479 168.737 173.347 148.869 197.769 148.869V134.62C165.491 134.619 139.23 160.88 139.23 193.158Z"/>
              <circle class="circle" cx="202.909" cy="246.909" r="18.9091"/>
              <circle class="circle" cx="294.5" cy="247.5" r="19.5"/>
              <path class="stroke" d="M211 315C230.5 339.5 267 339.5 286.5 315" stroke-width="14" stroke-linecap="round" stroke-linejoin="round"/>',
            "error" => '
            <svg width="70" height="70" viewBox="0 0 500 500" fill="none" xmlns="http://www.w3.org/2000/svg">
                <path class="fill" d="M463.462 249.37C451.607 233.86 435.222 221.993 416.893 215.538C416.134 171.154 379.793 135.279 335.232 135.279C328.254 135.279 321.296 136.189 314.487 137.989C303.401 124.179 289.415 112.693 273.778 104.593C255.786 95.2747 236.33 90.5499 215.953 90.5499C147.522 90.5499 91.6165 145.214 89.6058 213.167C46.0392 224.687 15 264.56 15 310.139C15 365.451 59.9993 410.45 115.311 410.45H383.688C439.001 410.45 484 365.451 484 310.139C484 287.961 476.897 266.948 463.462 249.37ZM383.688 396.202H115.311C67.8559 396.202 29.2486 357.595 29.2486 310.14C29.2486 269.332 58.2378 233.86 98.177 225.794L103.986 224.621L103.889 218.694C103.882 218.268 103.856 217.849 103.826 217.43C103.815 217.272 103.798 217.115 103.798 216.954C103.798 155.112 154.11 104.799 215.951 104.799C251.799 104.799 284.657 121.436 306.097 150.443L309.165 154.592L314.064 152.972C320.972 150.687 328.094 149.529 335.231 149.529C372.409 149.529 402.655 179.774 402.655 216.954C402.655 217.545 402.609 218.22 402.561 218.936C402.53 219.399 402.499 219.862 402.476 220.326L402.198 225.955L407.613 227.521C425.173 232.599 440.988 243.431 452.14 258.021C463.661 273.093 469.75 291.114 469.75 310.138C469.751 357.594 431.143 396.202 383.688 396.202Z"></path>
                <path class="fill" d="M139.23 193.158H153.479C153.479 168.737 173.347 148.869 197.769 148.869V134.62C165.491 134.619 139.23 160.88 139.23 193.158Z"></path>
                <circle class="circle" cx="202.909" cy="246.909" r="18.9091"></circle>
                <circle class="circle" cx="294.5" cy="247.5" r="19.5"></circle>
                <path class="stroke" d="M211 333.375C230.5 308.875 267 308.875 286.5 333.375" stroke-width="14" stroke-linecap="round" stroke-linejoin="round"></path>
            </svg>',
        ];

        if(isset($admin_session['data']['flash_message']) && $admin_session['data']['flash_message'])
        {
            $message = $admin_session['data']['flash_message']['message'];
            $type = $admin_session['data']['flash_message']['type'];
            echo "<section class=\"alert {$type}Alert\">\n";
            switch($type) {
                case 'success':
                    echo $cbIcon['success'];
                    break;
                default:
                    echo $cbIcon['error'];
                    break;
            }

            echo "<i class=\"fas alert__icon  fa-info-circle\"></i>";
            echo "<div class=\"alert__message\">{$message}</div>\n";
            echo "</section>\n";
            update_admin_session('flash_message', '');
        }

        if(!empty($this->extra_messages) && is_array($this->extra_messages)) {
            foreach($this->extra_messages as $message) {
                switch($message['type']) {
                    case 'success':
                    case 'error':
                        echo "<section class=\"alert alert--{$message['type']}\">\n";
                        echo "<i class=\"fas alert__icon  fa-info-circle\"></i>";
                        echo "{$message['message']}\n";
                        echo "</section>\n";
                        break;
                    default:
                        $this->output_error($message['message']);
                        break;
                }
            }
        }

        if($this->show_post_verify_error == true)
        {
            $this->output_error($lang->invalid_post_verify_key);
        }
        print <<<EOF

            <main class="pageContent" >
                <div class="upper">
                    <section class="userMenu">
                    <img src=$avatar alt="Avatar" class="avatar"/>
                    <a href="{$mybb->settings['bburl']}" class="button">
                      <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" width="24" height="24"><path fill="none" d="M0 0h24v24H0z"/><path d="M6.235 6.453a8 8 0 0 0 8.817 12.944c.115-.75-.137-1.47-.24-1.722-.23-.56-.988-1.517-2.253-2.844-.338-.355-.316-.628-.195-1.437l.013-.091c.082-.554.22-.882 2.085-1.178.948-.15 1.197.228 1.542.753l.116.172c.328.48.571.59.938.756.165.075.37.17.645.325.652.373.652.794.652 1.716v.105c0 .391-.038.735-.098 1.034a8.002 8.002 0 0 0-3.105-12.341c-.553.373-1.312.902-1.577 1.265-.135.185-.327 1.132-.95 1.21-.162.02-.381.006-.613-.009-.622-.04-1.472-.095-1.744.644-.173.468-.203 1.74.356 2.4.09.105.107.3.046.519-.08.287-.241.462-.292.498-.096-.056-.288-.279-.419-.43-.313-.365-.705-.82-1.211-.96-.184-.051-.386-.093-.583-.135-.549-.115-1.17-.246-1.315-.554-.106-.226-.105-.537-.105-.865 0-.417 0-.888-.204-1.345a1.276 1.276 0 0 0-.306-.43zM12 22C6.477 22 2 17.523 2 12S6.477 2 12 2s10 4.477 10 10-4.477 10-10 10z"/></svg>
                    </a>
                    <a href="index.php?action=logout&amp;my_post_key={$mybb->post_code}" class="button">
                      <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" width="24" height="24"><path fill="none" d="M0 0h24v24H0z"/><path d="M5 22a1 1 0 0 1-1-1V3a1 1 0 0 1 1-1h14a1 1 0 0 1 1 1v3h-2V4H6v16h12v-2h2v3a1 1 0 0 1-1 1H5zm13-6v-3h-7v-2h7V8l5 4-5 4z"/></svg>
                    </a>
                    </section>
EOF;
        $plugins->run_hooks("admin_upper_end");
    }



    function output_nav_tabs($tabs=array(), $active='')
    {
        global $plugins;
        $tabs = $plugins->run_hooks("admin_page_output_nav_tabs_start", $tabs);
        echo "<div class='pageTabs'>";
        echo "<div>";
        foreach($tabs as $id => $tab)
        {
            $class = '';
            if($id == $active) $class = ' tabActive';
            if(isset($tab['align']) == "right") $class .= " align_right";

            $target = '';
            if(isset($tab['link_target'])) $target = " target=\"{$tab['link_target']}\"";

            $rel = '';
            if(isset($tab['link_rel'])) $rel = " rel=\"{$tab['link_rel']}\"";
            if(!isset($tab['link'])) $tab['link'] = '';

            echo "\t\t<a href=\"{$tab['link']}\" class=\"pageTab{$class}\" {$target}{$rel}>{$tab['title']}</a>\n";
            $target = '';
        }
        echo "</div>";
        echo "</div>";
        echo "</div>";
        if($tabs[$active]['description'])
        {
            echo "\t<div class=\"tabDesc\">{$tabs[$active]['description']}</div>\n";
        }

        $arguments = array('tabs' => $tabs, 'active' => $active);
        $plugins->run_hooks("admin_page_output_nav_tabs_end", $arguments);
    }

    function output_tab_control($tabs=array(), $observe_onload=true, $id="tabs")
    {
        global $plugins;
        $tabs = $plugins->run_hooks("admin_page_output_tab_control_start", $tabs);
        $this->tab_control = "<ul class=\"tabs page-tabs\" id=\"{$id}\">\n";
        $tab_count = count($tabs);
        $done = 1;

        foreach($tabs as $anchor => $title)
        {
            $class = "";
            if($tab_count == $done)
            {
                $class .= " last";
            }
            if($done == 1)
            {
                $class .= " first";
            }
            ++$done;
            $this->tab_control .= "<li class=\"page-tabs__item page-tabs__item--{$class}\"><a href=\"#tab_{$anchor}\" class=\"page-tabs__link\" >{$title}</a></li>\n";
        }
        $this->tab_control .= "</ul>\n";
        echo $this->tab_control;
        $plugins->run_hooks("admin_page_output_tab_control_end", $tabs);
    }

    function output_footer($quit=true)
    {
        global $mybb, $maintimer, $db, $lang, $plugins;

        $args = array(
            'this' => &$this,
            'quit' => &$quit,
        );

        $plugins->run_hooks("admin_page_output_footer", $args);

        $memory_usage = get_friendly_size(get_memory_usage());

        $totaltime = format_time_duration($maintimer->stop());
        $querycount = $db->query_count;

        if(my_strpos(getenv("REQUEST_URI"), "?"))
        {
            $debuglink = htmlspecialchars_uni(getenv("REQUEST_URI")) . "&amp;debug=1#footer";
        }
        else
        {
            $debuglink = htmlspecialchars_uni(getenv("REQUEST_URI")) . "?debug=1#footer";
        }

        $copy_year = COPY_YEAR;
        print <<<EOT
</div>
</main>
</section>
    <footer>
        <span class="engine">Powered by <a href=\"https://mybb.com/\" target=\"_blank\" rel=\"noopener\">MyBulletinBoard</a>.</span>
        <span class="theme">Designed by <a href=\"https://cichorekfilip.pl/\" target=\"_blank\" rel=\"noopener\">Filip 'SimLay' Cichorek</a>.</span>
        <div style="display: none">{$lang->sprintf($lang->generated_in, $totaltime, $debuglink, $querycount, $memory_usage)} </div>



EOT;
        if($mybb->debug_mode) echo "<div class=\"wrapper wrapper--debug\"> {$db->explain} </div>";


        echo "</footer>\n";
        echo "</body>\n";
        echo "</html>\n";

        if($quit != false)
        {
            exit;
        }
    }

    function _build_menu()
    {
        global $sidebar;
        if(!is_array($this->_menu))
            return false;

        $build_menu = '<nav>';
        ksort($this->_menu);
        foreach($this->_menu as $items) {
            foreach($items as $menu_item) {
                if($menu_item['id'] == $this->active_module) {
                    $build_menu .= '<div class="moduleTab moduleActive moduleClick">';
                } else {
                    $build_menu .= '<div class="moduleTab">';
                }
                $menu_item['link'] = htmlspecialchars_uni($menu_item['link']);
                $menu_item_class = explode(" ", $menu_item['title'] )['0'];

                $sub_menu = $menu_item['submenu'];
                $sub_menu_title = $menu_item['title'];

                $navIcons = [
                    "home" => '<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" width="24" height="24">
                    <path fill="none" d="M0 0H24V24H0z"/>
                    <path class="first" d="M12 2c5.523 0 10 4.477 10 10s-4.477 10-10 10S2 17.523 2 12 6.477 2 12 2zm0 2c-4.418 0-8 3.582-8 8s3.582 8 8 8 8-3.582 8-8-3.582-8-8-8zm3.833 3.337c.237-.166.559-.138.763.067.204.204.23.526.063.76-2.18 3.046-3.38 4.678-3.598 4.897-.586.585-1.536.585-2.122 0-.585-.586-.585-1.536 0-2.122.374-.373 2.005-1.574 4.894-3.602zM17.5 11c.552 0 1 .448 1 1s-.448 1-1 1-1-.448-1-1 .448-1 1-1zm-11 0c.552 0 1 .448 1 1s-.448 1-1 1-1-.448-1-1 .448-1 1-1zm2.318-3.596c.39.39.39 1.023 0 1.414-.39.39-1.024.39-1.414 0-.39-.39-.39-1.024 0-1.414.39-.39 1.023-.39 1.414 0zM12 5.5c.552 0 1 .448 1 1s-.448 1-1 1-1-.448-1-1 .448-1 1-1z"/></svg>',
                    "config" => '<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" width="24" height="24">
                    <path fill="none" d="M0 0h24v24H0z"/>
                    <path  class="first" d="M22 12h-2V5H4v13.385L5.763 17H12v2H6.455L2 22.5V4a1 1 0 0 1 1-1h18a1 1 0 0 1 1 1v8zm-7.855 7.071a4.004 4.004 0 0 1 0-2.142l-.975-.563 1-1.732.976.563A3.996 3.996 0 0 1 17 14.126V13h2v1.126c.715.184 1.353.56 1.854 1.071l.976-.563 1 1.732-.975.563a4.004 4.004 0 0 1 0 2.142l.975.563-1 1.732-.976-.563c-.501.51-1.14.887-1.854 1.071V23h-2v-1.126a3.996 3.996 0 0 1-1.854-1.071l-.976.563-1-1.732.975-.563zM18 20a2 2 0 1 0 0-4 2 2 0 0 0 0 4z"/></svg>',
                    "forum" => '<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" width="24" height="24">
                      <path fill="none" d="M0 0h24v24H0z"/>
                      <path class="first" d="M6.455 19L2 22.5V4a1 1 0 0 1 1-1h18a1 1 0 0 1 1 1v14a1 1 0 0 1-1 1H6.455zm-.692-2H20V5H4v13.385L5.763 17zM8 10h8v2H8v-2z"/></svg>',
                    "user" => '<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" width="24" height="24"><path fill="none" d="M0 0h24v24H0z"/>
                    <path class="first" d="M4 22a8 8 0 1 1 16 0h-2a6 6 0 1 0-12 0H4zm8-9c-3.315 0-6-2.685-6-6s2.685-6 6-6 6 2.685 6 6-2.685 6-6 6zm0-2c2.21 0 4-1.79 4-4s-1.79-4-4-4-4 1.79-4 4 1.79 4 4 4z"/></svg>',
                    "style" => '<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" width="24" height="24"><path fill="none" d="M0 0h24v24H0z"/>
                    <path class="first" d="M19.228 18.732l1.768-1.768 1.767 1.768a2.5 2.5 0 1 1-3.535 0zM8.878 1.08l11.314 11.313a1 1 0 0 1 0 1.415l-8.485 8.485a1 1 0 0 1-1.414 0l-8.485-8.485a1 1 0 0 1 0-1.415l7.778-7.778-2.122-2.121L8.88 1.08zM11 6.03L3.929 13.1 11 20.173l7.071-7.071L11 6.029z"/></svg>',
                    "tools" => '<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" width="24" height="24">
                    <path fill="none" d="M0 0h24v24H0z"/>
                    <path class="first" d="M5.33 3.271a3.5 3.5 0 0 1 4.254 4.963l10.709 10.71-1.414 1.414-10.71-10.71a3.502 3.502 0 0 1-4.962-4.255L5.444 7.63a1.5 1.5 0 1 0 2.121-2.121L5.329 3.27zm10.367 1.884l3.182-1.768 1.414 1.414-1.768 3.182-1.768.354-2.12 2.121-1.415-1.414 2.121-2.121.354-1.768zm-6.718 8.132l1.414 1.414-5.303 5.303a1 1 0 0 1-1.492-1.327l.078-.087 5.303-5.303z"/></svg>',
                    "cloudboard" => '        <svg class="sygnet" xmlns="http://www.w3.org/2000/svg" width="495" height="343" viewBox="0 0 495 343" fill="none">
                              <path class="second" d="M448.462 181.37C436.607 165.86 420.222 153.993 401.893 147.538C401.134 103.154 364.793 67.2791 320.232 67.2791C313.254 67.2791 306.296 68.1891 299.487 69.9891C288.401 56.1791 274.415 44.6931 258.778 36.5931C240.786 27.2748 221.33 22.55 200.953 22.55C132.522 22.55 76.6165 77.2141 74.6058 145.167C31.0392 156.687 0 196.56 0 242.139C0 297.451 44.9993 342.45 100.311 342.45H368.688C424.001 342.45 469 297.451 469 242.139C469 219.961 461.897 198.948 448.462 181.37Z" fill="url(#paint0_linear)"/>
                              <path class="first" d="M474.462 159.37C462.607 143.86 446.222 131.993 427.893 125.538C427.134 81.1541 390.793 45.2791 346.232 45.2791C339.254 45.2791 332.296 46.1891 325.487 47.9891C314.401 34.1791 300.415 22.6931 284.778 14.5931C266.786 5.27479 247.33 0.549988 226.953 0.549988C158.522 0.549988 102.616 55.2141 100.606 123.167C57.0392 134.687 26 174.56 26 220.139C26 275.451 70.9993 320.45 126.311 320.45H394.688C450.001 320.45 495 275.451 495 220.139C495 197.961 487.897 176.948 474.462 159.37ZM394.688 306.202H126.311C78.8559 306.202 40.2486 267.595 40.2486 220.14C40.2486 179.332 69.2378 143.86 109.177 135.794L114.986 134.621L114.889 128.694C114.882 128.268 114.856 127.849 114.826 127.43C114.815 127.272 114.798 127.115 114.798 126.954C114.798 65.1121 165.11 14.7991 226.951 14.7991C262.799 14.7991 295.657 31.4361 317.097 60.4431L320.165 64.5921L325.064 62.9721C331.972 60.6871 339.094 59.5291 346.231 59.5291C383.409 59.5291 413.655 89.7741 413.655 126.954C413.655 127.545 413.609 128.22 413.561 128.936C413.53 129.399 413.499 129.862 413.476 130.326L413.198 135.955L418.613 137.521C436.173 142.599 451.988 153.431 463.14 168.021C474.661 183.093 480.75 201.114 480.75 220.138C480.751 267.594 442.143 306.202 394.688 306.202Z" fill="black"/>
                              <defs>
                              <linearGradient id="paint0_linear" x1="9.74915e-06" y1="23.0001" x2="234" y2="342" gradientUnits="userSpaceOnUse">
                              <stop offset="0.104167" stop-color="#30BEF5"/>
                              <stop offset="1" stop-color="#6292FF"/>
                              </linearGradient>
                              </defs>
                            </svg>',
                ];


                switch ($menu_item['id']) {
                    case 'home':
                        $navIcons['current'] = $navIcons['home'];
                        break;
                    case 'config':
                        $navIcons['current'] = $navIcons['config'];
                        break;
                    case 'forum':
                        $navIcons['current'] = $navIcons['forum'];
                        break;
                    case 'user':
                        $navIcons['current'] = $navIcons['user'];
                        break;
                    case 'style':
                        $navIcons['current'] = $navIcons['style'];
                        break;
                    case 'tools':
                        $navIcons['current'] = $navIcons['tools'];
                        break;
                    case 'cloudboard':
                        $navIcons['current'] = $navIcons['cloudboard'];
                        break;
                    default:
                        $navIcons['current'] = $navIcons['tools'];
                }

                if($menu_item['title'] == 'Start') {
                    $menu_item['title'] = 'Panel';
                } else if($menu_item['title'] == 'Home') {
                    $menu_item['title'] = 'Dashboard';
                }

                $build_menu .= "<a href=\"{$menu_item['link']}\" class=\"moduleTitle {$menu_item['id']}\"><div class='icon'>{$navIcons['current']}</div> <div class='title'>{$menu_item['title']}</div></a>\n";
                if ($sub_menu) {
                    $build_menu .= $this->_build_submenu($sub_menu_title, $sub_menu, $menu_item['id'],$menu_item['title'], $this->active_module);
                }

                $build_menu .= $sidebar;
                $build_menu .= '</div>';
            }
        }
        $build_menu .= '<div class="indicator"></div>';
        $build_menu .= '</nav>';

        return $build_menu;
    }

    function _build_submenu($title, $items=[], $item="", $mod="")
    {
        if (is_array($items)) {
            $sidebar = new sideBarItem();
            $sidebar->add_menu_items($items, $this->active_action, $item);
            return $sidebar->get_markup($item, $mod);
        }
        return '';
    }

    function _generate_breadcrumb()
    {
        if(!is_array($this->_breadcrumb_trail))
        {
            return false;
        }
        $trail = "";
        foreach($this->_breadcrumb_trail as $key => $crumb)
        {
            if(!empty($this->_breadcrumb_trail[$key+1]))
            {
                $trail .= "<a href=\"".$crumb['url']."\">".$crumb['name']."</a>";
                if(!empty($this->_breadcrumb_trail[$key+2]))
                {
                    $trail .= " &raquo; ";
                }
            }
            else
            {
                $trail .= " &raquo; <span class=\"active\">".$crumb['name']."</span>";
            }
        }
        return $trail;
    }


/** :login */
    function show_login($message="", $class="success")
    {
      global $plugins, $lang, $cp_style, $mybb;

      $args = array(
        'this' => &$this,
        'message' => &$message,
        'class' => &$class
      );

      $plugins->run_hooks('admin_page_show_login_start', $args);

      $copy_year = COPY_YEAR;

      $login_container_width = "";
      $login_label_width = "";

      // If the language string for "Username" is too cramped then use this to define how much larger you want the gap to be (in px)
      if(isset($lang->login_field_width))
      {
        $login_label_width = " style=\"width: ".((int)$lang->login_field_width+100)."px;\"";
        $login_container_width = " style=\"width: ".(410+((int)$lang->login_field_width))."px;\"";
      }

      //get image background
      ini_set("allow_url_fopen", 1);
      $Pburl = 'https://pixabay.com/api/?key=23669070-36e1c60621754c3f2c00f5c72&q=nature&image_type=photo&safesearch=true&per_page=3&orientation=horizontal';
      $json = file_get_contents($Pburl);
      $obj = json_decode($json);
      $img = $obj->hits[0];
      $pixabay = array(
          'id' => $img->id,
          'url' => $img->largeImageURL,
          'author' => $img->user,
          'authorUrl' => $img->pageURL,
      );
      if($pixabay['author']) {
        $cssPixabay = <<<EOF
        <style>
        #otherContent {
          background-image: url({$pixabay['url']})!important;
        }
        </style>
        EOF;
      }
      if($pixabay['author']) {
        $creditsPixabay = <<<EOF
          <div class="credits">
            &copy <a href="https://pixabay.com">Pixabay</a> - <a href="{$pixabay['authorUrl']}">{$pixabay['author']}</a>
          </div>
        EOF;
      }
      $login_page = <<<EOF
    <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
    <html xmlns="http://www.w3.org/1999/xhtml" lang="en">
    <head profile="http://gmpg.org/xfn/1">
    <title>{$lang->mybb_admin_login}</title>
    <meta name="author" content="MyBB Group" />
    <meta name="copyright" content="Copyright {$copy_year} MyBB Group." />
    <link rel="stylesheet" href="./styles/{$cp_style}/login.css" type="text/css" />
    <script type="text/javascript" src="../jscripts/jquery.js?ver=1823"></script>
    <script type="text/javascript" src="../jscripts/general.js?ver=1821"></script>
    <script type="text/javascript" src="./jscripts/admincp.js?ver=1821"></script>
    <script type="text/javascript">
    //<![CDATA[
    loading_text = '{$lang->loading_text}';
    //]]>
    </script>
    {$cssPixabay}
    </head>
    <body id="loginPage">
    <section id="otherContent">
    {$creditsPixabay}
    </section>
    EOF;
      if($message)
      {
        $login_page .= "<p id=\"message\" class=\"{$class}\"><span class=\"text\">{$message}</span></p>";
      }
      // Make query string nice and pretty so that user can go to his/her preferred destination
      $query_string = '';
      if($_SERVER['QUERY_STRING'])
      {
        $query_string = '?'.preg_replace('#adminsid=(.{32})#i', '', $_SERVER['QUERY_STRING']);
        $query_string = preg_replace('#my_post_key=(.{32})#i', '', $query_string);
        $query_string = str_replace('action=logout', '', $query_string);
        $query_string = preg_replace('#&+#', '&', $query_string);
        $query_string = str_replace('?&', '?', $query_string);
        $query_string = htmlspecialchars_uni($query_string);
      }
      switch($mybb->settings['username_method'])
      {
        case 0:
          $lang_username = $lang->username;
          break;
        case 1:
          $lang_username = $lang->username1;
          break;
        case 2:
          $lang_username = $lang->username2;
          break;
        default:
          $lang_username = $lang->username;
          break;
      }

      // Secret PIN
      global $config;
      if(isset($config['secret_pin']) && $config['secret_pin'] != '')
      {
        $secret_pin = "<div class=\"label\"{$login_label_width}><label for=\"pin\">{$lang->secret_pin}</label></div>
              <div class=\"field\"><input type=\"password\" name=\"pin\" id=\"pin\" class=\"text_input\" /></div>";
      }
      else
      {
        $secret_pin = '';
      }

      $login_lang_string = $lang->enter_username_and_password;

      switch($mybb->settings['username_method'])
      {
        case 0: // Username only
          $login_lang_string = $lang->sprintf($login_lang_string, $lang->login_username);
          break;
        case 1: // Email only
          $login_lang_string = $lang->sprintf($login_lang_string, $lang->login_email);
          break;
        case 2: // Username and email
        default:
          $login_lang_string = $lang->sprintf($login_lang_string, $lang->login_username_and_password);
          break;
      }

          $this_file = htmlspecialchars_uni($_SERVER['SCRIPT_NAME']);


      $lang->username = rtrim($lang->username, ":");
      $lang->password = rtrim($lang->password, ":");
      $login_page .= <<<EOF
      <section id="loginContent">
        <svg class="sygnet" xmlns="http://www.w3.org/2000/svg" width="495" height="343" viewBox="0 0 495 343" fill="none">
          <path d="M448.462 181.37C436.607 165.86 420.222 153.993 401.893 147.538C401.134 103.154 364.793 67.2791 320.232 67.2791C313.254 67.2791 306.296 68.1891 299.487 69.9891C288.401 56.1791 274.415 44.6931 258.778 36.5931C240.786 27.2748 221.33 22.55 200.953 22.55C132.522 22.55 76.6165 77.2141 74.6058 145.167C31.0392 156.687 0 196.56 0 242.139C0 297.451 44.9993 342.45 100.311 342.45H368.688C424.001 342.45 469 297.451 469 242.139C469 219.961 461.897 198.948 448.462 181.37Z" fill="url(#paint0_linear)"/>
          <path d="M474.462 159.37C462.607 143.86 446.222 131.993 427.893 125.538C427.134 81.1541 390.793 45.2791 346.232 45.2791C339.254 45.2791 332.296 46.1891 325.487 47.9891C314.401 34.1791 300.415 22.6931 284.778 14.5931C266.786 5.27479 247.33 0.549988 226.953 0.549988C158.522 0.549988 102.616 55.2141 100.606 123.167C57.0392 134.687 26 174.56 26 220.139C26 275.451 70.9993 320.45 126.311 320.45H394.688C450.001 320.45 495 275.451 495 220.139C495 197.961 487.897 176.948 474.462 159.37ZM394.688 306.202H126.311C78.8559 306.202 40.2486 267.595 40.2486 220.14C40.2486 179.332 69.2378 143.86 109.177 135.794L114.986 134.621L114.889 128.694C114.882 128.268 114.856 127.849 114.826 127.43C114.815 127.272 114.798 127.115 114.798 126.954C114.798 65.1121 165.11 14.7991 226.951 14.7991C262.799 14.7991 295.657 31.4361 317.097 60.4431L320.165 64.5921L325.064 62.9721C331.972 60.6871 339.094 59.5291 346.231 59.5291C383.409 59.5291 413.655 89.7741 413.655 126.954C413.655 127.545 413.609 128.22 413.561 128.936C413.53 129.399 413.499 129.862 413.476 130.326L413.198 135.955L418.613 137.521C436.173 142.599 451.988 153.431 463.14 168.021C474.661 183.093 480.75 201.114 480.75 220.138C480.751 267.594 442.143 306.202 394.688 306.202Z" fill="black"/>
          <defs>
          <linearGradient id="paint0_linear" x1="9.74915e-06" y1="23.0001" x2="234" y2="342" gradientUnits="userSpaceOnUse">
          <stop offset="0.104167" stop-color="#30BEF5"/>
          <stop offset="1" stop-color="#6292FF"/>
          </linearGradient>
          </defs>
        </svg>
        <h2>{$lang->please_login}</h2>
        <p>{$login_lang_string}</p>
        <form method="post" action="{$this_file}{$query_string}">

          <input type="text" name="username" id="username" placeholder="{$lang->username}" class="text_input initial_focus" />
          <input type="password" name="password" id="password" placeholder="{$lang->password}" class="text_input"/>

          <span class="buttons">
            <input type="submit" value="{$lang->login}" />
            <input type="hidden" name="do" value="login" />
            <a href="../member.php?action=lostpw" class="forget">{$lang->lost_password}</a>
          </span>

        </form>
      </section>
    </div>
    </body>
    </html>
    EOF;

      $args = array(
        'this' => &$this,
        'login_page' => &$login_page
      );

      $plugins->run_hooks('admin_page_show_login_end', $args);

      echo $login_page;
      exit;

    }


}

?>
