<?php
/**
 * This file is part of Cloudboard
 * @Author: Filip 'SimLay' Cichorek
 * @website: http://cichorekfilip.pl
 * Copyright (c) 2021
 **/
if (!defined('IN_MYBB')) {
    die("🇩‌🇮‌🇷‌🇪‌🇨‌🇹‌ 🇮‌🇳‌🇮‌🇹‌🇮‌🇦‌🇱‌🇮‌🇿‌🇦‌🇹‌🇮‌🇴‌🇳‌ 🇴‌🇫‌ 🇹‌🇭‌🇮‌🇸‌ 🇫‌🇮‌🇱‌🇪‌ 🇮‌🇸‌ 🇳‌🇴‌🇹‌ 🇦‌🇱‌🇱‌🇴‌🇼‌🇪‌🇩‌.<br /><br />🇵‌🇱‌🇪‌🇦‌🇸‌🇪‌ 🇲‌🇦‌🇰‌🇪‌ 🇸‌🇺‌🇷‌🇪‌ 🇮‌🇳‌_🇲‌🇾‌🇧‌🇧‌ 🇮‌🇸‌ 🇩‌🇪‌🇫‌🇮‌🇳‌🇪‌🇩‌. <br /><br />🇹‌🇴‌🇩‌🇦‌🇾‌ 🇮‌🇲‌🇵‌🇴‌🇸‌🇸‌🇮‌🇧‌🇱‌🇪‌ 🇧‌🇪‌🇨‌🇦‌🇲‌🇪‌ 🇵‌🇴‌🇸‌🇸‌🇮‌🇧‌🇱‌🇪‌");
}

/** Be sure lang is loaded  */
$plugins->add_hook('global_start', 'cbLang');
function cbLang(){
    global $mybb, $lang, $db, $CloudBoard;
    $lang->load('cloudboard');
}

function cloudboard_info() {
    global $mybb, $lang;
    return array(
        'name' => 'Cloudboard',
        'description' => $lang->cloudboard_desc,
        'author' => 'Filip \'SimLay\' Cichorek',
        'version' => '0.5.0b',
        'compatibility' => '18*',
    );
}

function cloudboard_install() {
    require_once('cloudboard/settings/settings.php');
    CloudBoardSettings::install();
    require_once('cloudboard/acp/settings.php');
    CloudBoardACP::install();
    require_once('cloudboard/menu/settings.php');
    CloudBoardMenu::install();
    require_once('cloudboard/team/settings.php');
    CloudBoardTeam::install();
    require_once('cloudboard/top/settings.php');
    CloudBoardTop::install();
    require_once('cloudboard/logs/settings.php');
    CloudBoardLogs::install();
    rebuild_settings();


}

function cloudboard_uninstall() {
    require_once('cloudboard/settings/settings.php');
    CloudBoardSettings::uninstall();
    require_once('cloudboard/acp/settings.php');
    CloudBoardACP::uninstall();
    require_once('cloudboard/menu/settings.php');
    CloudBoardMenu::uninstall();
    require_once('cloudboard/team/settings.php');
    CloudBoardTeam::uninstall();
    require_once('cloudboard/top/settings.php');
    CloudBoardTop::uninstall();
    require_once('cloudboard/logs/settings.php');
    CloudBoardLogs::uninstall();
    rebuild_settings();
}

function cloudboard_is_installed() {
    global $cache, $installed, $info;

    $info = cloudboard_info();
    $installed = $cache->read("cloudboard_cache");
    if ($installed[$info['name']]) {
        $testvar = true;
        return true;
    }
}

function cloudboard_activate() {
}
function cloudboard_deactivate() {
}
require_once('cloudboard/settings/settings.php');
CloudBoardSettings::settings();
require_once('cloudboard/top/main.php');
$plugins->add_hook('global_start', ['CloudBoardTopMain', 'Posts']);
CloudBoardTopMain::Posts();
$plugins->add_hook('global_start', ['CloudBoardTopMain', 'Threads']);
CloudBoardTopMain::Threads();
$plugins->add_hook('global_start', ['CloudBoardTopMain', 'Rep']);
CloudBoardTopMain::Rep();
$plugins->add_hook('global_start', ['CloudBoardTopMain', 'LastPosts']);
CloudBoardTopMain::LastPosts();
$plugins->add_hook('global_start', ['CloudBoardTopMain', 'LastThreads']);
CloudBoardTopMain::LastThreads();




    /** ============= :ACP ============= */
require_once('cloudboard/acp/main.php');
// Everywhere
$plugins->add_hook('admin_page_output_footer', ['CloudBoardACPMain', 'everywhere']);
CloudBoardACPMain::everywhere();
// Homepage
$plugins->add_hook('admin_home_index_output_message', ['CloudBoardACPMain', 'homepage']);
CloudBoardACPMain::homepage();



/** ============= :Menu ============= */
require_once('cloudboard/menu/main.php');
CloudBoardMenuMain::show();

/** ============= :Team ============= */
$plugins->add_hook('global_start', ['CloudBoardTeamMain', 'show']);
require_once('cloudboard/team/main.php');
CloudBoardTeamMain::show();

/** ============= :Logs ============= */
function cbAdminLog( $actType, $module, $element)
{
    global $db, $mybb, $lang;

    $mybb->binary_fields['cblogs'] = ['ip' => true];
    switch ($actType) {
        case 'new':
            $type = $lang->cloudboard_log_new;
            break;
        case 'edit':
            $type = $lang->cloudboard_log_edit;
            break;
        case 'del':
            $type = $lang->cloudboard_log_delete;
            break;
        case 'newsub':
            $type = $lang->cloudboard_log_new_sub;
            break;
        case 'editsub':
            $type = $lang->cloudboard_log_edit_sub;
            break;
        case 'delsub':
            $type = $lang->cloudboard_log_delete_sub;
            break;
        case 'new_back':
            $type = $lang->cloudboard_log_new_back;
            break;
        case 'insert_back':
            $type = $lang->cloudboard_log_insert_back;
            break;
        default:
           $type = $lang->cloudboard_log_idk;
    }

    $logdata = array(
        "uid" => (int)$mybb->user['uid'],
        "module" => $module,
        "description" => $type.$element,
        "date" => TIME_NOW,
        "ip" => $db->escape_binary(my_inet_pton(get_ip()))
    );

    $db->insert_query("cblogs", $logdata);
};

/** ============= :Head ============= */
$plugins->add_hook('global_start', 'cbHead');
function cbHead(){
    global $cbHead;
    $cbHead = "<script type=\"text/javascript\" src=\"./jscripts/cloudboard/global.js\"></script>";
    $cbHead .="<link href=\"https://cdn.jsdelivr.net/npm/remixicon@2.5.0/fonts/remixicon.css\" rel=\"stylesheet\">";


    /** default css */
    $cbMenuCSS = 1;
    if($cbMenuCSS) {
        $cbHead .= "<link type=\"text/css\" rel=\"stylesheet\" href=\"./inc/plugins/cloudboard/_default/menu.css\" />";
    }
    $cbTopCSS = 1;
    if($cbTopCSS) {
        $cbHead .= "<link type=\"text/css\" rel=\"stylesheet\" href=\"./inc/plugins/cloudboard/_default/top.css\" />";
    }
    $cbTeamCSS = 1;
    if($cbTeamCSS) {
        $cbHead .= "<link type=\"text/css\" rel=\"stylesheet\" href=\"./inc/plugins/cloudboard/_default/team.css\" />";
    }
}
/** ============= :LastUserAvatar ============= */
function cbLastUserAvatar() {
    global $db, $mybb, $urlavatar, $cbLastUserAvatar;
    $query = $db->write_query("SELECT avatar FROM mybb_users ORDER BY `uid` DESC LIMIT 1");
    if ($query->num_rows == 1) {
        $result = $db->fetch_array($query);
        if (empty($result['avatar'])) {
            $urla = 'images/default_avatar.png';
        } else {
            $urla = $result['avatar'];
        }
        $cbLastUserAvatar = "<img src='{$urla}' alt='avatar' />";
    }
}



/** Make variables beautifull  */
$plugins->add_hook('global_start', 'cbVariables');
function cbVariables(){
    global $mybb, $lang, $db, $CloudBoard,
    $cbHead, $cbMenu, $cbTeam, $cbTopPosts, $cbTopThreads, $cbTopRep,
    $cbLastUserAvatar, $cbTopLastPosts, $cbTopLastThreads;
    $CloudBoard = array(
        'Head' => $cbHead,
        'Menu' => $cbMenu,
        'Team' => $cbTeam,
        'LastUserAvatar' => $cbLastUserAvatar,
        'TopPosts' => $cbTopPosts,
        'TopThreads' => $cbTopThreads,
        'TopRep' => $cbTopRep,
        'LastPosts' => $cbTopLastPosts,
        'LastThreads' => $cbTopLastThreads,
    );

}
